/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20160108-64
 * Copyright (c) 2000 - 2016 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of ssdt4.dat, Wed Jan 25 18:09:24 2017
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000589 (1417)
 *     Revision         0x01
 *     Checksum         0x06
 *     OEM ID           "AMITCG"
 *     OEM Table ID     "PROC"
 *     OEM Revision     0x00000001 (1)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20120711 (538052369)
 */
DefinitionBlock ("ssdt4.aml", "SSDT", 1, "AMITCG", "PROC", 0x00000001)
{
    Device (\_SB.TPM)
    {
        Name (TMF1, Zero)
        Name (TMF2, Zero)
        Name (TRST, 0x02)
        Method (_HID, 0, NotSerialized)  // _HID: Hardware ID
        {
            Return (0x310CD041)
        }

        Name (_STR, Unicode ("TPM 1.2 Device"))  // _STR: Description String
        Name (_UID, One)  // _UID: Unique ID
        Name (_CRS, ResourceTemplate ()  // _CRS: Current Resource Settings
        {
            Memory32Fixed (ReadOnly,
                0xFED40000,         // Address Base
                0x00005000,         // Address Length
                )
        })
        Method (_STA, 0, NotSerialized)  // _STA: Status
        {
            Return (0x0F)
        }

        OperationRegion (TSMI, SystemIO, 0xB2, 0x02)
        Field (TSMI, ByteAcc, NoLock, Preserve)
        {
            INQ,    8, 
            DAT,    8
        }

        Method (SVAL, 1, NotSerialized)
        {
            DAT = ToInteger (Arg0)
            INQ = 0x4D
        }
    }

    Scope (\_SB.TPM)
    {
        OperationRegion (PVAR, SystemMemory, 0xC7F50798, 0x0030)
        Field (PVAR, AnyAcc, NoLock, Preserve)
        {
            P_WR,   8, 
            P_PD,   8, 
            P_NR,   8, 
            PMOR,   8, 
            P_RC,   32, 
            P_AP,   8, 
            P_SR,   8, 
            Offset (0x10), 
            RP00,   8, 
            RP01,   8, 
            RP02,   8, 
            RP03,   8, 
            RP04,   8, 
            RP05,   8, 
            RP06,   8, 
            RP07,   8, 
            RP08,   8, 
            RP09,   8, 
            RP10,   8, 
            RP11,   8, 
            RP12,   8, 
            RP13,   8, 
            RP14,   8, 
            RP15,   8, 
            RP16,   8, 
            RP17,   8, 
            RP18,   8, 
            RP19,   8, 
            RP20,   8, 
            RP21,   8, 
            RP22,   8
        }

        Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
        {
            Name (_T_2, Zero)  // _T_x: Emitted by ASL Compiler
            Name (_T_1, Zero)  // _T_x: Emitted by ASL Compiler
            Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
            If ((Arg0 == ToUUID ("3dddfaa6-361b-4eb4-a424-8d10089d1653") /* Physical Presence Interface */))
            {
                While (One)
                {
                    _T_0 = ToInteger (Arg2)
                    If ((_T_0 == Zero))
                    {
                        Return (Buffer (0x02)
                        {
                             0xFF, 0x01                                       /* .. */
                        })
                    }
                    ElseIf ((_T_0 == One))
                    {
                        Return ("1.2")
                    }
                    ElseIf ((_T_0 == 0x02))
                    {
                        If ((P_AP == One))
                        {
                            Return (0x02)
                        }

                        ToInteger (DerefOf (Arg3 [Zero]), TMF2) /* \_SB_.TPM_.TMF2 */
                        If ((TMF2 > 0x16))
                        {
                            Return (One)
                        }

                        P_PD = TMF2 /* \_SB_.TPM_.TMF2 */
                        P_WR = TMF2 /* \_SB_.TPM_.TMF2 */
                        SVAL (0xFF)
                        Return (P_SR) /* \_SB_.TPM_.P_SR */
                    }
                    ElseIf ((_T_0 == 0x03))
                    {
                        Name (PPI1, Package (0x02)
                        {
                            Zero, 
                            Zero
                        })
                        If ((P_AP == One))
                        {
                            PPI1 [Zero] = One
                            Return (PPI1) /* \_SB_.TPM_._DSM.PPI1 */
                        }

                        If ((P_PD > 0x16))
                        {
                            PPI1 [Zero] = One
                            Return (PPI1) /* \_SB_.TPM_._DSM.PPI1 */
                        }

                        PPI1 [One] = P_PD /* \_SB_.TPM_.P_PD */
                        Return (PPI1) /* \_SB_.TPM_._DSM.PPI1 */
                    }
                    ElseIf ((_T_0 == 0x04))
                    {
                        If ((P_AP == One))
                        {
                            Return (Zero)
                        }

                        If ((P_WR == 0x0F))
                        {
                            Return (Zero)
                        }

                        Return (TRST) /* \_SB_.TPM_.TRST */
                    }
                    ElseIf ((_T_0 == 0x05))
                    {
                        Name (PPI2, Package (0x03)
                        {
                            Zero, 
                            Zero, 
                            Zero
                        })
                        If ((P_AP == One))
                        {
                            PPI2 [Zero] = One
                            Return (PPI2) /* \_SB_.TPM_._DSM.PPI2 */
                        }

                        If ((P_NR == 0xFF))
                        {
                            PPI2 [Zero] = One
                            Return (PPI2) /* \_SB_.TPM_._DSM.PPI2 */
                        }

                        PPI2 [One] = P_NR /* \_SB_.TPM_.P_NR */
                        PPI2 [0x02] = P_RC /* \_SB_.TPM_.P_RC */
                        Return (PPI2) /* \_SB_.TPM_._DSM.PPI2 */
                    }
                    ElseIf ((_T_0 == 0x06))
                    {
                        Return (0x03)
                    }
                    ElseIf ((_T_0 == 0x07))
                    {
                        If ((P_AP == One))
                        {
                            Return (0x03)
                        }

                        ToInteger (DerefOf (Arg3 [Zero]), TMF2) /* \_SB_.TPM_.TMF2 */
                        If ((TMF2 > 0x16))
                        {
                            Return (One)
                        }

                        P_PD = TMF2 /* \_SB_.TPM_.TMF2 */
                        P_WR = TMF2 /* \_SB_.TPM_.TMF2 */
                        SVAL (0xFF)
                        Return (P_SR) /* \_SB_.TPM_.P_SR */
                    }
                    ElseIf ((_T_0 == 0x08))
                    {
                        If ((P_AP == One))
                        {
                            Return (0x02)
                        }

                        ToInteger (DerefOf (Arg3 [Zero]), TMF2) /* \_SB_.TPM_.TMF2 */
                        While (One)
                        {
                            _T_1 = TMF2 /* \_SB_.TPM_.TMF2 */
                            If ((_T_1 == Zero))
                            {
                                Return (RP00) /* \_SB_.TPM_.RP00 */
                            }
                            ElseIf ((_T_1 == One))
                            {
                                Return (RP01) /* \_SB_.TPM_.RP01 */
                            }
                            ElseIf ((_T_1 == 0x02))
                            {
                                Return (RP02) /* \_SB_.TPM_.RP02 */
                            }
                            ElseIf ((_T_1 == 0x03))
                            {
                                Return (RP03) /* \_SB_.TPM_.RP03 */
                            }
                            ElseIf ((_T_1 == 0x04))
                            {
                                Return (RP04) /* \_SB_.TPM_.RP04 */
                            }
                            ElseIf ((_T_1 == 0x05))
                            {
                                Return (RP05) /* \_SB_.TPM_.RP05 */
                            }
                            ElseIf ((_T_1 == 0x06))
                            {
                                Return (RP06) /* \_SB_.TPM_.RP06 */
                            }
                            ElseIf ((_T_1 == 0x07))
                            {
                                Return (RP07) /* \_SB_.TPM_.RP07 */
                            }
                            ElseIf ((_T_1 == 0x08))
                            {
                                Return (RP08) /* \_SB_.TPM_.RP08 */
                            }
                            ElseIf ((_T_1 == 0x09))
                            {
                                Return (RP09) /* \_SB_.TPM_.RP09 */
                            }
                            ElseIf ((_T_1 == 0x0A))
                            {
                                Return (RP10) /* \_SB_.TPM_.RP10 */
                            }
                            ElseIf ((_T_1 == 0x0B))
                            {
                                Return (RP11) /* \_SB_.TPM_.RP11 */
                            }
                            ElseIf ((_T_1 == 0x0C))
                            {
                                Return (RP12) /* \_SB_.TPM_.RP12 */
                            }
                            ElseIf ((_T_1 == 0x0D))
                            {
                                Return (RP13) /* \_SB_.TPM_.RP13 */
                            }
                            ElseIf ((_T_1 == 0x0E))
                            {
                                Return (RP14) /* \_SB_.TPM_.RP14 */
                            }
                            ElseIf ((_T_1 == 0x0F))
                            {
                                Return (RP15) /* \_SB_.TPM_.RP15 */
                            }
                            ElseIf ((_T_1 == 0x10))
                            {
                                Return (RP16) /* \_SB_.TPM_.RP16 */
                            }
                            ElseIf ((_T_1 == 0x11))
                            {
                                Return (RP17) /* \_SB_.TPM_.RP17 */
                            }
                            ElseIf ((_T_1 == 0x12))
                            {
                                Return (RP18) /* \_SB_.TPM_.RP18 */
                            }
                            ElseIf ((_T_1 == 0x13))
                            {
                                Return (RP19) /* \_SB_.TPM_.RP19 */
                            }
                            ElseIf ((_T_1 == 0x14))
                            {
                                Return (RP20) /* \_SB_.TPM_.RP20 */
                            }
                            ElseIf ((_T_1 == 0x15))
                            {
                                Return (RP21) /* \_SB_.TPM_.RP21 */
                            }
                            ElseIf ((_T_1 == 0x16))
                            {
                                Return (RP22) /* \_SB_.TPM_.RP22 */
                            }
                            Else
                            {
                                Return (Zero)
                            }

                            Break
                        }

                        Return (Zero)
                    }
                    Else
                    {
                    }

                    Break
                }
            }
            ElseIf ((Arg0 == ToUUID ("376054ed-cc13-4675-901c-4756d7f2d45d")))
            {
                While (One)
                {
                    _T_2 = ToInteger (Arg2)
                    If ((_T_2 == Zero))
                    {
                        Return (Buffer (One)
                        {
                             0x03                                             /* . */
                        })
                    }
                    ElseIf ((_T_2 == One))
                    {
                        ToInteger (DerefOf (Arg3 [Zero]), TMF1) /* \_SB_.TPM_.TMF1 */
                        PMOR = TMF1 /* \_SB_.TPM_.TMF1 */
                        SVAL (0xFF)
                        Return (Zero)
                    }
                    Else
                    {
                    }

                    Break
                }
            }

            Return (Buffer (One)
            {
                 0x00                                             /* . */
            })
        }
    }
}

